/*****************************************************************************
 * btoa.c - read a binary file and output it in terse ASCII format           *
 *                                                                           *
 * Heavily modified from undump by Mike Haaland <mikeh@hypercom.com>         *
 *                                                                           *
 * author: Sean Dwyer <ewe2@can.org.au>                                      *
 * this program can take the output of atob and reconstruct binaries         *
 * Usage: btoa < textfile > binary file                                      *
 *                                                                           *
 *****************************************************************************/


#include <stdio.h>
#include <stdlib.h>

/* ansi decls */
char *ohex(char *,int);

/* global variables */
char *fmt = "%s\n"; /* the output string */
int maxwide = 16;   /* maximum ascii characters per buffer (half the actual
                     * number to allow proper hex conversion)
                     */
int maxline = 16;   /* maximum line length */

/*--------------------------------------------------------------------------*\
 * char *ohex(char *,int) - modifies an ASCII string to return a hex string *
 * and halves the size of the string in the process                         *
\*--------------------------------------------------------------------------*/


char *ohex(char *s, int ch)
{
    char tstr[10]; /* hold 8 + 2 bits */

	sprintf(tstr,"%02x",ch);
	*s++ = tstr[0];
	*s++ = tstr[1];
	*s = '\0';
	return(s);
}

/*--------------------------------------------------------------------------*\
 * main() - takes input on stdin, converts the stream to hex and prints out *
 * ASCII lines of hex characters.                                           *
\*--------------------------------------------------------------------------*/


int main()
{
    int ch;
    int i = 0;
    int k = 0;

    char buf[80];
    char *s;
    

    s = buf;
    *buf = '\0';

    while((ch = fgetc(stdin)) !=EOF) {
        s = ohex(s,ch);
        i++;
        if (i == maxwide)     /* buffer is full */
        {
            printf(fmt,buf);
            k++;
            i = 0;            /* reset the buffer and count */
            s = buf;
            *buf = '\0';
            if (k == maxline) /* reset the line */
                    k = 0;
        }
    }
    if (i > 0)               /* print whatever's left */
        printf(fmt,buf);

    return (0);
}
